OsmoBSC> enable

OsmoBSC# show timer
net: T4 = 5 s	Timeout to receive BSSMAP RESET ACKNOWLEDGE from the MSC (default: 5 s)
net: T7 = 10 s	inter-BSC/MSC Handover outgoing, BSSMAP HO Required to HO Command timeout (default: 10 s)
net: T8 = 10 s	inter-BSC/MSC Handover outgoing, BSSMAP HO Command to final Clear timeout (default: 10 s)
net: T10 = 6 s	RR Assignment (default: 6 s)
net: T101 = 10 s	inter-BSC/MSC Handover incoming, BSSMAP HO Request to HO Accept (default: 10 s)
net: T3101 = 3 s	RR Immediate Assignment (default: 3 s)
net: T3103 = 5 s	Handover (default: 5 s)
net: T3105 = 100 ms	Physical Information (default: 100 ms, range: [1 .. inf])
net: T3107 = 5 s	(unused) (default: 5 s)
net: T3109 = 5 s	RSL SACCH deactivation (default: 5 s)
net: T3111 = 2 s	Wait time before RSL RF Channel Release (default: 2 s)
net: T3113 = 7 s	Paging (default: 7 s)
net: T3115 = 10 s	(unused) (default: 10 s)
net: T3117 = 10 s	(unused) (default: 10 s)
net: T3119 = 10 s	(unused) (default: 10 s)
net: T3122 = 10 s	Wait time after RR Immediate Assignment Reject (default: 10 s)
net: T3141 = 10 s	(unused) (default: 10 s)
net: T3212 = 5	Periodic Location Update timer, sent to MS (1 = 6 minutes) (default: 5)
net: X4 = 60 s	After Clear Request, wait for MSC to Clear Command (sanity) (default: 60 s)
net: X5 = 5 s	Timeout to switch dynamic timeslot PCHAN modes (default: 5 s)
net: X6 = 5 s	Timeout for RSL Channel Activate ACK after sending RSL Channel Activate (default: 5 s)
net: X7 = 5 s	Timeout for RSL IPA CRCX ACK after sending RSL IPA CRCX (default: 5 s)
net: X8 = 5 s	Timeout for RSL IPA MDCX ACK after sending RSL IPA MDCX (default: 5 s)
net: X9 = 5 s	Timeout for availability of MGW endpoint (default: 5 s)
net: X10 = 5 s	Timeout for fully configured MGW endpoint (default: 5 s)
net: X11 = 5 s	Timeout for Perform Location Response from SMLC (default: 5 s)
net: X12 = 5 s	Timeout for obtaining TA after BSSLAP TA Request (default: 5 s)
net: X13 = 5 s	Timeout for RR Channel Mode Modify ACK (BSC <-> MS) (default: 5 s)
net: X14 = 5 s	Timeout for RSL Channel Mode Modify ACK (BSC <-> BTS) (default: 5 s)
net: X16 = 1000 ms	Granularity for all_allocated:* rate counters: amount of milliseconds that one counter increment represents. See also X17, X18 (default: 1000 ms)
net: X17 = 0 ms	Rounding threshold for all_allocated:* rate counters: round up to the next counter increment after this many milliseconds. If set to half of X16 (or 0), employ the usual round() behavior: round up after half of a granularity period. If set to 1, behave like ceil(): already increment the counter immediately when all channels are allocated. If set >= X16, behave like floor(): only increment after a full X16 period of all channels being occupied. See also X16, X18 (default: 0 ms)
net: X18 = 60000 ms	Forget-sum period for all_allocated:* rate counters: after this amount of idle time, forget internally cumulated time remainders. Zero to always keep remainders. See also X16, X17. (default: 60000 ms)
net: X25 = 5 s	Timeout for initial user data after an MSC initiated an SCCP connection to the BSS (default: 5 s)
net: X28 = 30 s	Interval at which to try to recover a BORKEN lchan (default: 30 s)
net: X3105 = 17	Ny1: Maximum number of Physical Information (re)transmissions (default: 17)
net: X3111 = 4 s	Wait time after lchan was released in error (should be T3111 + 2s) (default: 4 s)
net: X3113 = 60 s	Maximum Paging Request Transmit Delay Threshold: If the estimated transmit delay of the messages in the paging queue surpasses this threshold, then new incoming paging requests will if possible replace a request in retransmission state from the queue or otherwise be discarded, hence limiting the size of the queue and maximum delay of its scheduled requests. X3113 also serves as the upper boundary for dynamic T3113 when estimating the expected maximum delay to get a response (default: 60 s)
net: X3210 = 20 s	After L3 Complete, wait for MSC to confirm (default: 20 s)
mgw: X2427 = 5 s	timeout for MGCP response from MGW (default: 5 s)

OsmoBSC# show timer T3111
T3111 = 2 s	Wait time before RSL RF Channel Release (default: 2 s)

OsmoBSC# # specifically test legacy timers that are moved to X timers
OsmoBSC# show timer T993111
% Legacy: timer T993111 is now X3111
X3111 = 4 s	Wait time after lchan was released in error (should be T3111 + 2s) (default: 4 s)
OsmoBSC# show timer T993210
% Legacy: timer T993210 is now X3210
X3210 = 20 s	After L3 Complete, wait for MSC to confirm (default: 20 s)
OsmoBSC# show timer T999
% Legacy: timer T999 is now X4
X4 = 60 s	After Clear Request, wait for MSC to Clear Command (sanity) (default: 60 s)

OsmoBSC# configure terminal
OsmoBSC(config)# network
OsmoBSC(config-net)# timer
net: T4 = 5 s	Timeout to receive BSSMAP RESET ACKNOWLEDGE from the MSC (default: 5 s)
net: T7 = 10 s	inter-BSC/MSC Handover outgoing, BSSMAP HO Required to HO Command timeout (default: 10 s)
net: T8 = 10 s	inter-BSC/MSC Handover outgoing, BSSMAP HO Command to final Clear timeout (default: 10 s)
net: T10 = 6 s	RR Assignment (default: 6 s)
net: T101 = 10 s	inter-BSC/MSC Handover incoming, BSSMAP HO Request to HO Accept (default: 10 s)
net: T3101 = 3 s	RR Immediate Assignment (default: 3 s)
net: T3103 = 5 s	Handover (default: 5 s)
net: T3105 = 100 ms	Physical Information (default: 100 ms, range: [1 .. inf])
net: T3107 = 5 s	(unused) (default: 5 s)
net: T3109 = 5 s	RSL SACCH deactivation (default: 5 s)
net: T3111 = 2 s	Wait time before RSL RF Channel Release (default: 2 s)
net: T3113 = 7 s	Paging (default: 7 s)
net: T3115 = 10 s	(unused) (default: 10 s)
net: T3117 = 10 s	(unused) (default: 10 s)
net: T3119 = 10 s	(unused) (default: 10 s)
net: T3122 = 10 s	Wait time after RR Immediate Assignment Reject (default: 10 s)
net: T3141 = 10 s	(unused) (default: 10 s)
net: T3212 = 5	Periodic Location Update timer, sent to MS (1 = 6 minutes) (default: 5)
net: X4 = 60 s	After Clear Request, wait for MSC to Clear Command (sanity) (default: 60 s)
net: X5 = 5 s	Timeout to switch dynamic timeslot PCHAN modes (default: 5 s)
net: X6 = 5 s	Timeout for RSL Channel Activate ACK after sending RSL Channel Activate (default: 5 s)
net: X7 = 5 s	Timeout for RSL IPA CRCX ACK after sending RSL IPA CRCX (default: 5 s)
net: X8 = 5 s	Timeout for RSL IPA MDCX ACK after sending RSL IPA MDCX (default: 5 s)
net: X9 = 5 s	Timeout for availability of MGW endpoint (default: 5 s)
net: X10 = 5 s	Timeout for fully configured MGW endpoint (default: 5 s)
net: X11 = 5 s	Timeout for Perform Location Response from SMLC (default: 5 s)
net: X12 = 5 s	Timeout for obtaining TA after BSSLAP TA Request (default: 5 s)
net: X13 = 5 s	Timeout for RR Channel Mode Modify ACK (BSC <-> MS) (default: 5 s)
net: X14 = 5 s	Timeout for RSL Channel Mode Modify ACK (BSC <-> BTS) (default: 5 s)
net: X16 = 1000 ms	Granularity for all_allocated:* rate counters: amount of milliseconds that one counter increment represents. See also X17, X18 (default: 1000 ms)
net: X17 = 0 ms	Rounding threshold for all_allocated:* rate counters: round up to the next counter increment after this many milliseconds. If set to half of X16 (or 0), employ the usual round() behavior: round up after half of a granularity period. If set to 1, behave like ceil(): already increment the counter immediately when all channels are allocated. If set >= X16, behave like floor(): only increment after a full X16 period of all channels being occupied. See also X16, X18 (default: 0 ms)
net: X18 = 60000 ms	Forget-sum period for all_allocated:* rate counters: after this amount of idle time, forget internally cumulated time remainders. Zero to always keep remainders. See also X16, X17. (default: 60000 ms)
net: X25 = 5 s	Timeout for initial user data after an MSC initiated an SCCP connection to the BSS (default: 5 s)
net: X28 = 30 s	Interval at which to try to recover a BORKEN lchan (default: 30 s)
net: X3105 = 17	Ny1: Maximum number of Physical Information (re)transmissions (default: 17)
net: X3111 = 4 s	Wait time after lchan was released in error (should be T3111 + 2s) (default: 4 s)
net: X3113 = 60 s	Maximum Paging Request Transmit Delay Threshold: If the estimated transmit delay of the messages in the paging queue surpasses this threshold, then new incoming paging requests will if possible replace a request in retransmission state from the queue or otherwise be discarded, hence limiting the size of the queue and maximum delay of its scheduled requests. X3113 also serves as the upper boundary for dynamic T3113 when estimating the expected maximum delay to get a response (default: 60 s)
net: X3210 = 20 s	After L3 Complete, wait for MSC to confirm (default: 20 s)
mgw: X2427 = 5 s	timeout for MGCP response from MGW (default: 5 s)

OsmoBSC(config-net)# # Using the legacy 'timer Txxx' still works:
OsmoBSC(config-net)# timer T3111
T3111 = 2 s	Wait time before RSL RF Channel Release (default: 2 s)
OsmoBSC(config-net)# timer T3111 23
OsmoBSC(config-net)# timer T3111
T3111 = 23 s	Wait time before RSL RF Channel Release (default: 2 s)
OsmoBSC(config-net)# timer T3111 default
OsmoBSC(config-net)# timer T3111
T3111 = 2 s	Wait time before RSL RF Channel Release (default: 2 s)

OsmoBSC(config-net)# # Using the new timer group commands also works:
OsmoBSC(config-net)# timer net T3111
net: T3111 = 2 s	Wait time before RSL RF Channel Release (default: 2 s)
OsmoBSC(config-net)# timer net T3111 42
OsmoBSC(config-net)# timer net T3111
net: T3111 = 42 s	Wait time before RSL RF Channel Release (default: 2 s)
OsmoBSC(config-net)# timer net T3111 default
OsmoBSC(config-net)# timer net T3111
net: T3111 = 2 s	Wait time before RSL RF Channel Release (default: 2 s)
OsmoBSC(config-net)# timer mgw
mgw: X2427 = 5 s	timeout for MGCP response from MGW (default: 5 s)
OsmoBSC(config-net)# timer mgw X2427
mgw: X2427 = 5 s	timeout for MGCP response from MGW (default: 5 s)
OsmoBSC(config-net)# timer mgw X2427 42
OsmoBSC(config-net)# timer mgw X2427
mgw: X2427 = 42 s	timeout for MGCP response from MGW (default: 5 s)
OsmoBSC(config-net)# timer mgw X2427 default
OsmoBSC(config-net)# timer mgw X2427
mgw: X2427 = 5 s	timeout for MGCP response from MGW (default: 5 s)

OsmoBSC(config-net)# # specifically test legacy timers that are moved to X timers
OsmoBSC(config-net)# timer T993111
% Legacy: timer T993111 is now X3111
X3111 = 4 s	Wait time after lchan was released in error (should be T3111 + 2s) (default: 4 s)
OsmoBSC(config-net)# timer T993111 1
% Legacy: timer T993111 is now X3111
OsmoBSC(config-net)# timer T993111
% Legacy: timer T993111 is now X3111
X3111 = 1 s	Wait time after lchan was released in error (should be T3111 + 2s) (default: 4 s)
OsmoBSC(config-net)# timer T993111 default
% Legacy: timer T993111 is now X3111
OsmoBSC(config-net)# timer T993111
% Legacy: timer T993111 is now X3111
X3111 = 4 s	Wait time after lchan was released in error (should be T3111 + 2s) (default: 4 s)

OsmoBSC(config-net)# timer T993210
% Legacy: timer T993210 is now X3210
X3210 = 20 s	After L3 Complete, wait for MSC to confirm (default: 20 s)
OsmoBSC(config-net)# timer T993210 2
% Legacy: timer T993210 is now X3210
OsmoBSC(config-net)# timer T993210
% Legacy: timer T993210 is now X3210
X3210 = 2 s	After L3 Complete, wait for MSC to confirm (default: 20 s)
OsmoBSC(config-net)# timer T993210 default
% Legacy: timer T993210 is now X3210
OsmoBSC(config-net)# timer T993210
% Legacy: timer T993210 is now X3210
X3210 = 20 s	After L3 Complete, wait for MSC to confirm (default: 20 s)

OsmoBSC(config-net)# timer T999
% Legacy: timer T999 is now X4
X4 = 60 s	After Clear Request, wait for MSC to Clear Command (sanity) (default: 60 s)
OsmoBSC(config-net)# timer T999 3
% Legacy: timer T999 is now X4
OsmoBSC(config-net)# timer T999
% Legacy: timer T999 is now X4
X4 = 3 s	After Clear Request, wait for MSC to Clear Command (sanity) (default: 60 s)
OsmoBSC(config-net)# timer T999 default
% Legacy: timer T999 is now X4
OsmoBSC(config-net)# timer T999
% Legacy: timer T999 is now X4
X4 = 60 s	After Clear Request, wait for MSC to Clear Command (sanity) (default: 60 s)
